#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "CGI_Engine.h"

#ifdef _DEBUG
extern FILE		*pDbgLog;
#endif

bool CGI_Engine::readDataFile()
{
//	m_DefaultPage = _DEFAULT_PAGE;

//	if(query_info->GetMode().compare("制御端末") == 0){
		m_DefaultPage = _CONTROL_MAIN_PAGE;
//	}
//	if(query_info->GetMode().compare("会議室端末") == 0){
//		m_DefaultPage = _MEETING_ROOM_PAGE;
//	}
	return true;
}

std::string CGI_Engine::getMapData(std::string keyName)
{
	return "";
}

std::string	CGI_Engine::getHTMLFileName(std::string pageName, std::string command)
{
	std::string	result = m_DefaultPage;

#ifdef _DEBUG
	fprintf(pDbgLog, "CGI_Engine::getHTMLFileName\n");
#endif

	return result;
}

//bool CGI_Engine::writeHTML(std::string	pageName)
bool CGI_Engine::writeHTML()
{
	bool	result = true;
	int		run_mode = _RUN_MODE_DEFAULT;
	int		sysErr;
	FILE	*pHtmlFile = 0;
	char	*ret;
	char	buff[1024];
	std::string	htmlFileName;
	std::string	html_data;
	std::string loopKey;
	std::string	front, rear, script;
	size_t	script_start = std::string::npos, script_end = std::string::npos;
	size_t	command_pos = std::string::npos, html_pos;

	readDataFile();

	// HTMLファイル名を取得する
	htmlFileName = getHTMLFileName(query_info->GetSubFunctionName(), query_info->GetCommand());

	if(htmlFileName.length() > 0){
		// HTMLファイルを開く
		pHtmlFile = fopen(htmlFileName.c_str(), "r");
	}
	else{
		std::cout << "機能[ " << query_info->GetSubFunctionName() << " ]は存在していません <br />";
	}
	if(pHtmlFile != 0){

		while(1){
			// 一行読み込みを行う
			memset(buff, 0, sizeof(buff));
			ret = fgets(buff, sizeof(buff), pHtmlFile);

			if(ret == 0){
				break;
			}

			// 行末の改行を除去する
			if(buff[strlen(buff) -1] == 0x0a){
				buff[strlen(buff) -1] = 0;
			}
			else if((buff[strlen(buff) -2] == 0x0d) && (buff[strlen(buff) -1] == 0x0a)){
				buff[strlen(buff) -1] = 0;
				buff[strlen(buff) -2] = 0;
			}else if(buff[strlen(buff) -1] == 0x0d){
				buff[strlen(buff) -1] = 0;
			}
			html_data = buff;

			// スクリプトの可能性ありの場合
			// 解析を行う <?RTC ?>を探して、実行する
			/*
			 * スクリプトスタート"<?RTC"を探す
			 * 後続に'loop'が指定されているか確認する
			 * 'loop'が指定されていた場合は、基準を取得する
			 * 継承先呼び出しを行う
			 */
			switch(run_mode){
				case _RUN_MODE_GET_LOOP_RANGE:
					// ループ範囲のバッファリング
					if(html_data.find(_SCRIPT_END_TAG) == std::string::npos){
						loopList.push_back(html_data);
#ifdef _DEBUG
		fprintf(pDbgLog, "ScriptLine = %s\n", html_data.c_str());
#endif
					}
					else{
						run_mode = _RUN_MODE_LOOP;
					}
					html_data = "";
					break;
				case _RUN_MODE_LOOP:
					// ループ処理の実行
#ifdef _DEBUG
		fprintf(pDbgLog, "loopProc = %s\n", loopKey.c_str());
#endif
					loopProc(loopKey);
					run_mode = _RUN_MODE_DEFAULT;
					break;
				case _RUN_MODE_SCRIPT:
					// スクリプト実行

					if(rear.length() > 0){
						html_data = runScript(script) + rear + "\n" + html_data;
//						html_data = html_data + rear;
						// スクリプト後方部分出力なので、スクリプトブロック終了
						run_mode = _RUN_MODE_DEFAULT;
					}
					else{
						html_data = runScript(script) + "\n" + html_data;
					}

					script_end = html_data.find(_SCRIPT_END_TAG);
					if(script_end != std::string::npos){
						// スクリプト前方部分抽出
						// スクリプト後方部分抽出
						run_mode = _RUN_MODE_DEFAULT;
					}
					else{
						script = html_data;
					}
					break;
				case _RUN_MODE_DEFAULT:		// 通常読み込みモード
				default:
					front = "";
					rear = "";
					script_start = html_data.find(_SCRIPT_START_TAG);
					script_end = html_data.find(_SCRIPT_END_TAG);
					command_pos = std::string::npos;
#ifdef _DEBUG
		fprintf(pDbgLog, "ScriptMode = %d\n", script_start);
#endif

					if(script_start != std::string::npos){
						// スクリプト開始タグを検出した
						// スクリプト解析モードへ移行
						run_mode = _RUN_MODE_SCRIPT;

						command_pos = html_data.find("loop");
#ifdef _DEBUG
		fprintf(pDbgLog, "ScriptCommand = %d\n", command_pos);
#endif
						if((script_start + strlen(_SCRIPT_START_TAG) + 1) == command_pos){
							// ループ命令を検出
							// ループキーの取り出し
							loopKey = html_data.substr(command_pos + strlen("loop") + 1);
							// ループ範囲週出モードへ移行
							run_mode = _RUN_MODE_GET_LOOP_RANGE;
							html_pos = script_start;
							script_start = command_pos + loopKey.length();
#ifdef _DEBUG
		fprintf(pDbgLog, "Loop = %s\n", loopKey.c_str());
#endif
						}
						else{
							html_pos = script_start;
							script_start = script_start + strlen(_SCRIPT_START_TAG) + 1;
						}

						// スクリプトの前方部分を抽出
						front = html_data.substr(0, html_pos);

						if(script_end != std::string::npos){
							// スクリプトの後方部分を抽出
							rear = html_data.substr(script_end + strlen(_SCRIPT_END_TAG));
						}

						// スクリプト部分を抽出する
						script = html_data.substr(script_start, script_end - script_start);

						// スクリプト前方部分は普通のHTMLなので普通に出力する
						html_data = front;
					}
					break;
			}

			// 解析結果を出力する
			if(html_data.length() > 0){
				html_data = html_data + "\n";
				std::cout << html_data << std::endl;
			}
		}
		sysErr = fclose(pHtmlFile);
	}
	else{
#ifdef _DEBUG
		fprintf(pDbgLog, "%s ファイルの読み込み失敗\n", htmlFileName.c_str());
#endif
//		std::cout << htmlFileName << ", の読み込みに失敗しました。<br />";
		std::cout << htmlFileName;
	}
	return result;
}

bool CGI_Engine::loopProc(std::string loopKey)
{
#ifdef _DEBUG
		fprintf(pDbgLog, "CGI_Engine::loopProc\n");
#endif
	return true;
}
bool CGI_Engine::writeLine()
{
	std::string		html_data;
	// ループ行を1行ずつ処理していく
#ifdef _DEBUG
		fprintf(pDbgLog, "CGI_Engine::writeLine\n");
#endif
	for(std::vector<std::string>::iterator it = loopList.begin(); it != loopList.end(); it++){
		html_data = runScript(*it);
		std::cout << html_data << std::endl;
	}
	return true;
}

std::string CGI_Engine::runScript(std::string script)
{
	size_t		value_start = std::string::npos, value_end = std::string::npos;
	std::string loopKey, varName, value;
	std::string	result;

#ifdef _DEBUG
		fprintf(pDbgLog, "CGI_Engine::runScript\n");
#endif
	// 変数探す
	if(script.length() > 0){
		value_start	= script.find(_VALUE_MARKER_START);
		value_end	= script.find(_VALUE_MARKER_END);
		if( (value_start != std::string::npos) && (value_end != std::string::npos)){
			varName		= script.substr(value_start + 1, value_end - value_start - 1);
#ifdef _DEBUG
		fprintf(pDbgLog, "GetMarker = %s\n", varName.c_str());
#endif
			// 関数判別
			if( (varName[varName.length()-1] != ')') && (varName[varName.length()-2] != '(') ){
				value		= getMapData(varName);
			}
			else{
				if (varName.compare("Now()") == 0){
					time_t curTime, pCurTime;
					struct tm *pTimeData;
					char		strTime[20];

					// 現在時刻を整形して出力
					curTime		= time(&pCurTime);
					pTimeData	= localtime(&pCurTime);
					memset(strTime, 0, sizeof(strTime));
					sprintf(strTime, "%04d/%02d/%02d %02d:%02d",	pTimeData->tm_year + 1900,
																	pTimeData->tm_mon + 1,
																	pTimeData->tm_mday,
																	pTimeData->tm_hour,
																	pTimeData->tm_min);
					value = strTime;
				}
				if (varName.compare("RequestResult()") == 0){
					/*
					 * 	強制的にスクリプトを埋め込む
					 *	onLoad=\"alert('登録しました');\"
					 */
					value = getMapData("RequestResult");
				}
				if (varName.compare("FieldHeaders()") == 0){
					value = getMapData("FieldHeaders");
				}
				if (varName.compare("FieldValues()") == 0){
					value = getMapData("FieldValues");
				}
			}
			result		= script.substr(0, value_start) + value + script.substr(value_end + 1);
		}
		else{
			result = script;
		}
	}
	else{
		result = "";
	}
	return result;
}

void CGI_Engine::setNextRecordData()
{
}
