#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <memory.h>
#include <stdio.h>
#include <stdlib.h>

#include "Tools.h"
#include "TSProperty.h"
#include "SystemControl.h"

#ifdef _DEBUG
extern FILE		*pDbgLog;
#endif

SystemControl::SystemControl(QueryInfo *query) : CGI_Engine(query)
{
	// 自身が管理するHTMLページのマップを作る
	htmlList.insert(string_pair("default", "./cgi-bin/SystemState.html"));
	htmlList.insert(string_pair("ListView", "./cgi-bin/TableRecord.html"));
	htmlList.insert(string_pair("ModData", "./cgi-bin/DataEditor.html"));
	htmlList.insert(string_pair("UpdateData", "./cgi-bin/DataUpdate.html"));

//SubFunction=UpdateData&KeyValue=" + keyName + "&Mode=" + folderName + "&File=" + fileName;"

	curData.insert(string_pair("FieldHeaders", ""));
	curData.insert(string_pair("FieldValues", ""));
	curData.insert(string_pair("FolderKey", ""));
	curData.insert(string_pair("FileName", ""));
	curData.insert(string_pair("KeyValue", ""));
	curData.insert(string_pair("DataKey", ""));
	curData.insert(string_pair("UpdateResult", ""));

}

SystemControl::~SystemControl()
{
}

bool SystemControl::readDataFile()
{
	std::string dataFullPath;
	std::string	dataFolder;

	if(query_info->GetSubFunctionName() == "default")	return true;

	folderKey = query_info->GetMode();
	if(folderKey.length() == 0)	dataFolder = "default";

	{
		TS_Property	systemProperty;

//		dataFolder = systemProperty.getValue(dataFolder);
		dataFolder = systemProperty[folderKey];
		if(dataFolder.length() == 0) dataFolder = "/tmp/";
//		if(dataFolder[dataFolder.length()-1] != '/')	dataFolder = dataFolder + "/";
/*
 * 2010.12.22 データファイルのファイル名はプロパティファイルで定義するように変更
 * ただし、複数ファイルがある場合は、フォルダまでしか指定していない。
 * 最終文字が'/'の場合は、フォルダ指定であり、ターゲットファイルが複数ある事を意味する。
		// データファイルを特定する
		dataFile = query_info->GetQueryPair("File");
*/
		curData["FolderKey"]	= folderKey;
		curData["FileName"]		= dataFile;
		curData["KeyValue"]		= query_info->GetQueryPair("KeyValue");
		curData["DataKey"]		= "\'" + folderKey + "\', \'" + dataFile + "\', \'" + curData["KeyValue"] + "\'";

		// データ読み込みを行う
		dataFullPath = dataFolder + dataFile;
		{
			std::string		buff;
			field_list		recordData;
			record_it		recData;

			textData.openFile(dataFullPath);
			if(textData.readData()){
				recordData.clear();
				recordData = textData.getFields();

				// フィールド名退避
				buff = "<tr>";
				for(str_it it = recordData.begin(); it != recordData.end(); it++){
//					std::cout << *it << std::endl;
					buff = buff + "<td>" + *it + "</td>";
				}

				// 編集画面へのリンクを設定する？
				buff = buff + "<td></td>";

				buff = buff + "</tr>\n";
				curData["FieldHeaders"] = buff;
/*
				recData = textData.getTopRecord();
				for(; recData != (record_it)NULL; ){
					for(str_it it = recordData.begin(); it != recordData.end(); it++){
						// レコード情報退避？？
						std::cout << (recData->second)[*it] << std::endl;
					}
					recData = textData.getNextRecord();
				}
*/
			}
		}
	}

	return true;
}

std::string SystemControl::getMapData(std::string keyName)
{
	return curData[keyName];
}

std::string	SystemControl::getHTMLFileName(std::string pageName, std::string command)
{
#ifdef _DEBUG
fprintf(pDbgLog, "Mod HTMLFileName = %s\n", pageName.c_str());
fflush(pDbgLog);
#endif
	if(pageName.compare("UpdateData") == 0){
		field_list		recordData, fieldData;
		record_it		recData;
		field_data		dataRecord;

		// データ更新を行い、結果を[UpdateResult]に格納する。
		fieldData = textData.getFields();

		dataRecord = textData[query_info->GetQueryPair("KeyValue")];

		for(str_it it = fieldData.begin(); it != fieldData.end(); it++){
			recordData.push_back(query_info->GetQueryPair(*it));
		}

		textData.writeRecord(query_info->GetQueryPair("KeyValue"), recordData);

		textData.writeData();
	}
	return htmlList[pageName];
}

bool SystemControl::loopProc(std::string loopKey)
{
	std::string		buff;
	field_list		recordData;
	record_it		recData;
	field_data		dataRecord;
	std::string		mainKey = "";

//	loopKey = "records";
	if(loopKey.compare("records") == 0){
		recordData = textData.getFields();
		recData = textData.getTopRecord();
		for(; recData != (record_it)NULL; ){
			mainKey = "";
			buff = "<tr>";
			for(str_it it = recordData.begin(); it != recordData.end(); it++){
				// レコード情報退避？？
				buff = buff + "<td>" + (recData->second)[*it] + "</td>\n";
				if(mainKey.length() == 0)	mainKey = (recData->second)[*it];
			}

			// 編集用リンクを作る
			buff = buff + "<td><input type=\"button\" value=\"編集\" onClick=\"ModData(";
			buff = buff + "\'" + folderKey + "\', " + "\'" + dataFile + "\', " + "\'" + mainKey + "\')\"></td>";

			buff = buff + "</tr>";
			curData["FieldValues"] = buff;
			writeLine();
			recData = textData.getNextRecord();
		}
		return true;
	}

	if(loopKey.compare("mod_data") == 0){
		recordData = textData.getFields();
		dataRecord = textData[query_info->GetQueryPair("KeyValue")];
		for(str_it it = recordData.begin(); it != recordData.end(); it++){
			curData["FieldHeaders"]	= *it;
			curData["FieldValues"]	= dataRecord[*it];
			writeLine();
		}

		return true;
	}
	return false;
}
