#include <stdio.h>
#include <stdlib.h>
#include <map>
#include <string>
#include <iostream>
#include <fstream>
#include <memory.h>

#include "Tools.h"
#include "QueryInfo.h"
#include "CGI_Engine.h"
#include "FunctionList.h"
#include "main.h"

typedef std::pair <std::string, CGI_Engine*> page_pair;

#ifdef _DEBUG
extern FILE		*pDbgLog;
#endif

int main()
{
	std::map <std::string, CGI_Engine*> pageData;	// ページマップ
	std::string	funcName;
	int		sysErr;

	UNUSED_VARIABLE(sysErr);
#ifdef _DEBUG
	pDbgLog = fopen("debug.log", "a");
#endif
/*
	// かるーくテキストDBのテストを行う
	{
		TextDataFile	textData("./test.tdb", true);
		field_list		recordData;
		record_it		recData;

		textData.addField("Test-1");
		textData.addField("Test-2");
		textData.addField("Test-3");
		textData.addField("Test-4");
		textData.addField("Test-5");
		textData.addField("Test-6");

		recordData.push_back("Data-1-1");
		recordData.push_back("Data-1-2");
		recordData.push_back("Data-1-3");
		recordData.push_back("Data-1-4");
		recordData.push_back("Data-1-5");
		recordData.push_back("Data-1-6");
		textData.writeRecord("Data-1-1", recordData);
		recordData.clear();

		recordData.push_back("Data-2-1");
		recordData.push_back("Data-2-2");
		recordData.push_back("Data-2-3");
		recordData.push_back("Data-2-4");
		recordData.push_back("Data-2-5");
		recordData.push_back("Data-2-6");
		textData.writeRecord("Data-2-1", recordData);
		recordData.clear();

		recordData.push_back("Data-3-1");
		recordData.push_back("Data-3-2");
		recordData.push_back("Data-3-3");
		recordData.push_back("Data-3-4");
		recordData.push_back("Data-3-5");
		recordData.push_back("Data-3-6");
		textData.writeRecord("Data-3-1", recordData);
		recordData.clear();

		textData.writeData();

		textData.openFile();
		textData.readData();
		recordData.clear();
		recordData = textData.getFields();
		std::cout << "Read Field Data" << std::endl;
		for(str_it it = recordData.begin(); it != recordData.end(); it++){
			std::cout << *it << std::endl;
		}

		recData = textData.getTopRecord();
		for(; recData != (record_it)NULL; ){
			for(str_it it = recordData.begin(); it != recordData.end(); it++){
				std::cout << (recData->second)[*it] << std::endl;
			}
			recData = textData.getNextRecord();
		}

	}
*/
	// HTTPリクエスト情報を取り出す
	QueryInfo	query_info;

	query_info.ReadQueryData();

#ifdef _DEBUG
		fprintf(pDbgLog, "PageData Ready\n");
		fflush(pDbgLog);
#endif

	/*
	 * 表示する画面は複数あるので、その都度表示を考える必要がある
	 * 基本は、HTMLを用意しておいて、それを読み込んで出力する。
	 */
	pageData.insert(page_pair("FrontDesk", new FrontDesk(&query_info)));
	pageData.insert(page_pair("GoFrontDesk", new FrontDesk(&query_info)));
	pageData.insert(page_pair("SystemControl", new SystemControl(&query_info)));
	if(query_info.IsQueryData()){
		// データ有り処理
		if(query_info.GetQueryPair("GetIP").length() > 0){
			// IPアドレス取得
			std::cout << "Content-type: text/html\n\n";
			std::cout << query_info.GetRemoteIP() << std::endl;
#ifdef _DEBUG
		fprintf(pDbgLog, "RemoteIPAddress = (%s)\n", query_info.GetRemoteIP().c_str());
#endif
		}
		else{
			// ページ表示処理
			std::cout << "Content-type: text/html\n\n";
			funcName = query_info.GetFunctionName();
#ifdef _DEBUG
		fprintf(pDbgLog, "PageName = (%s)\n", funcName.c_str());
		fflush(pDbgLog);
#endif
			if(pageData[funcName] != 0){
				pageData[funcName]->writeHTML();
			}
		}
	}
#ifdef _DEBUG
	else{
		fprintf(pDbgLog, "none query\n" );
		fflush(pDbgLog);
	}
#endif
	/*
	for(std::map <std::string, CGI_Engine*>::iterator it = pageData.begin(); it != pageData.end(); it++){
		delete (it->second);
	}
	*/
#ifdef _DEBUG
	sysErr = fclose(pDbgLog);
#endif

	return 1;
}

void writeHtmlFile(std::string htmlFileName)
{
	FILE	*pHtmlFile;
	char	buff[1024];
	char	*ret;

	// HTMLファイルを開く
	pHtmlFile = fopen(htmlFileName.c_str(), "r");
	if(pHtmlFile != 0){

		while(1){
			// 一行読み込みを行う
			memset(buff, 0, sizeof(buff));
			ret = fgets(buff, sizeof(buff), pHtmlFile);
			if(ret == 0)	break;
			std::cout << buff;
		}
	}
	fclose(pHtmlFile);
}
