#!/usr/bin/env python
# -*- coding: utf-8 -*-

import subprocess, codecs, sys
from pyJuliusRTC.parsejuliusdict import JuliusDict
from BeautifulSoup import BeautifulSoup

sys.stdout = codecs.getwriter('utf-8')(sys.stdout, errors = "replace")
sys.stderr = codecs.getwriter('utf-8')(sys.stderr, errors = "replace")

if len(sys.argv) >= 2 and sys.argv[1] == "tiny":
    url = "http://www2s.biglobe.ne.jp/~suzakihp/ju0000.html"
else:
    url = "http://www2s.biglobe.ne.jp/~suzakihp/ju0001.html"
p1 = subprocess.Popen(["wget", "-O", "-", url], stdout=subprocess.PIPE)
p2 = subprocess.Popen(["nkf", "-SwXm0"], stdin=p1.stdout, stdout=subprocess.PIPE)

html = p2.communicate()[0]
soup = BeautifulSoup(html)

table = soup.find("table")

dic = JuliusDict('/usr/share/julius-runkit/model/lang_m/web.60k.htkdic')

print '''<?xml version="1.0" encoding="UTF-8"?>
<lexicon version="1.0"
     xmlns="http://www.w3.org/2005/01/pronunciation-lexicon"
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
     xsi:schemaLocation="http://www.w3.org/2005/01/pronunciation-lexicon
                         http://www.w3.org/TR/2007/CR-pronunciation-lexicon-20071212/pls.xsd"
     alphabet="X-KANA" xml:lang="jp">'''

for row in table.findAll('tr')[1:]:
    col = row.findAll('td')

    rank = int(col[0].string)
    name = col[1].string
    fmulti = (col[2].string == '*')
    stat = int(col[3].string)
    print '  <lexeme>'
    print '    <grapheme>'+name+'</grapheme>'
    for c in col[4:]:
        if c and c.string:
            s = c.string.replace(u"☆", "").replace(u"★", "")
            print '    <phoneme>{{X-KANA|' + dic.katakana2hiragana(s) + '}}</phoneme>'
    print '  </lexeme>'
print '</lexicon>'
