/*
 * TSProperty.cpp
 *
 *  Created on: 2010/12/07
 *      Author: yotubata
 */
#include <fstream>
#include <iostream>
#include "Tools.h"
#include "TSProperty.h"

TS_Property::TS_Property()
{
	// プロパティファイルの読み込みを行う
	*this = TS_Property(TS_SYSTEM_PROPERTY_FILE);
}

TS_Property::TS_Property(const std::string fileName)
{
	readFile(fileName);
}

TS_Property::~TS_Property()
{
}

std::string TS_Property::getValue(std::string key)
{
	std::string	result = property_data["default"];

	if(property_data.find(key) != property_data.end()){
		result = property_data[key];
	}

	return result;
}

bool TS_Property::readFile(const std::string fileName)
{
	bool			result = true;
	std::ifstream	ifsDataFile;
std::cout << fileName << std::endl;
	ifsDataFile.open(fileName.c_str(), std::ios::in);

	if(ifsDataFile){
		std::string	recordString;
		std::vector< std::string >	recordData;

		property_data.clear();
		while(getline(ifsDataFile, recordString)){
			if(recordString.length() > 1){
				int	index;

				// コメント行は削除する
				index = recordString.find(";");
				if(index == 0){
					continue;
				}
				index = recordString.find("#");
				if(index == 0){
					continue;
				}
				// データあり

				if(recordString.length() > 1){
					recordData = string_token(recordString, " =");
					if(recordData.size() == 2){
						// プロパティデータありなのでデータの格納を行う
						property_data.insert(PropertyPair(recordData[0], recordData[1]));
					}
				}
			}
		}
	}
	else{
		std::cout << "Read file open error!" << std::endl;
		result = false;
	}

	return result;
}

bool TS_Property::writeFile(const std::string fileName)
{
	return false;
}
