/*
 * TSProperty.h
 *
 *  Created on: 2010/12/07
 *      Author: yotubata
 */

#ifndef TSPROPERTY_H_
#define TSPROPERTY_H_

#include <string>
#include <vector>
#include <map>

#define TS_SYSTEM_PROPERTY_FILE	"/etc/RSXXXSystem.conf"

typedef std::map<std::string, std::string> PropertyValue;
typedef PropertyValue::value_type			PropertyPair;
typedef PropertyValue::iterator			PropertyIt;

class TS_Property
{
public:
	TS_Property();							// ファイルの読み込みを行う
	TS_Property(const std::string fileName);		// ファイルの読み込みを行う
	~TS_Property();

	std::string getValue(std::string key);

public:
	std::string operator[](std::string key)	{ return getValue(key); };

private:
	bool	readFile(const std::string fileName);
	bool	writeFile(const std::string fileName);

private:
	PropertyValue	property_data;
	std::string		propFileName;
};

#endif /* TSPROPERTY_H_ */
