/*
 * Tools.cpp
 *
 *  Created on: 2010/12/03
 *      Author: yotubata
 */
#include <fstream>
#include <stdlib.h>
#include <sstream>
#include <strstream>
#include <stdio.h>
#include <memory.h>

#include "Tools.h"

/**
 * @brief 文字列を指定された区切り文字で分解し、分解したデータを返す
 * @return 分解された文字列のリスト
 */
std::vector<std::string> string_token(const std::string line, const char* tok)
{
	char *token, *str;
	char	data[1024];
	std::string	key_word;
	std::vector<std::string> ret;

	memset(data, 0, sizeof(data));
	strcpy(data, line.c_str());
	str = data;
	while(1){
		token = strtok(str, tok);
		if(token == 0)	break;
		key_word = token;
		ret.push_back(key_word);
		str = 0;
	}
	return ret;
}

std::string int_to_string(int val)
{

	std::stringstream ss;

	ss << val;
	return ss.str();
}

int	string_to_int(std::string val)
{
	int	result;
	std::istrstream ss(val.data());

	ss >> result;

	return result;
}


std::string GetDateTimeStr(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%Y/%m/%d %H:%M:%d", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%Y/%m/%d %H:%M:%d", localtime(&curTime));
	}
	result = timeStr;

	return result;
}

std::string GetDateTimeNum(time_t *dateTime)
{
	std::string	result;
	size_t		timeStrLen;
	char		timeStr[24];

	if(dateTime != NULL)
		timeStrLen = strftime(timeStr, sizeof(timeStr), "%Y%m%d%H%M%d", localtime(dateTime));
	else{
		time_t pCurTime, curTime;

		curTime		= time(&pCurTime);
		timeStrLen	= strftime(timeStr, sizeof(timeStr), "%Y%m%d%H%M%d", localtime(&curTime));
	}
	result = timeStr;

	return result;
}
